/**
 * Created by CSL on 2017-10-22.
 */
let mongoose = require('mongoose');
let Schema = mongoose.Schema;

let calcItemSchema = new Schema({
    ID: Number,
    code: String,
    name: String,
    fieldName: String,
    dispExpr: String,
    expression: String,
    compiledExpr: String,
    statement: String,
    feeRateID: Number,
    feeRate: Number,
    labourCoeID: Number
},{versionKey:false, _id: false});

let templateSchema = new Schema({
    ID: Number,
    name: String,
    calcItems: [calcItemSchema]
},{versionKey:false, _id: false});

let stdCalcPrograms = new Schema({
    ID: Number,
    region: String,
    libName: String,
    templates: [templateSchema]
},{versionKey:false, _id: false});

let projectCalcPrograms = new Schema({
    ID: String,
    projectID: Number,
    name: String,
    libID: Number,
    libName: String,
    templates: [templateSchema]
},{versionKey:false});

mongoose.model('std_calc_programs', stdCalcPrograms, 'std_calc_programs');
mongoose.model('calc_programs', projectCalcPrograms, 'calc_programs');