/**
 * Created by CSL on 2017-09-22.
 * 项目属性之人工系数。
 */
let labourCoeView = {
    datas: [],
    spread: null,
    sheet: null,

    init(){
        let me = this;

        function getStdLabourCoeFilesHtml(stdLabourCoeLibs) {
            let result = '<option value="">请选择人工系数标准库</option>';
            if (stdLabourCoeLibs.length <= 0) {
                return result;
            };

            for (let lib of stdLabourCoeLibs){
                result += '<option value="'+ lib.id +'">'+ lib.name +'</option>';
            };
            return result;
        };

        let stdLCHtml = getStdLabourCoeFilesHtml(projectInfoObj.projectInfo.engineeringInfo.artificial_lib);
        $("#std_labour_coe_files").html(stdLCHtml);
    },

    buildSheet: function (){
        let me = this;
        if (me.spread) {
            me.spread.destroy();
            me.spread = null;
        };
        me.spread = new GC.Spread.Sheets.Workbook($("#labourCoeSpread")[0], { sheetCount: 1 });
        me.spread.options.tabStripVisible = false;
        me.spread.options.showVerticalScrollbar = false;
        me.spread.options.showHorizontalScrollbar = false;
        me.spread.options.rowHeight = 50;
        let sheetArea = GC.Spread.Sheets.SheetArea;
        let sheet = me.spread.getSheet(0);
        me.sheet = sheet;
        sheet.suspendPaint();
        sheet.suspendEvent();
        sheet.setColumnCount(1, sheetArea.viewport);
        sheet.setColumnWidth(0, 180, sheetArea.viewport);
        sheet.setRowCount(1, sheetArea.colHeader);
        sheet.setRowCount(20, sheetArea.viewport);
        sheet.setRowHeight(0, 30, sheetArea.colHeader);

        sheet.resumeEvent();
        sheet.resumePaint();
    },

    loadData(datas){          // 树结构转换二维表显示，行列转换
        let me = this;
        me.datas = datas;
        let libArr = [];
        for (let v of me.datas) {if (!v.ParentID) libArr.push(v);};

        // 行名称
        let row = 0;
        for (let v of me.datas) {
            if (v.ParentID == libArr[0].ID) {
                me.sheet.setText(row, 0, v.name, GC.Spread.Sheets.SheetArea.viewport);
                row++;
            };
        };

        me.sheet.setColumnCount(libArr.length + 1, GC.Spread.Sheets.SheetArea.viewport);    // 还多一列行名称
        me.sheet.setRowCount(row, GC.Spread.Sheets.SheetArea.viewport);
        me.sheet.setText(0, 0, "定额工种", GC.Spread.Sheets.SheetArea.colHeader);
        me.sheet.options.isProtected = true;
        me.sheet.getRange(-1, 1, -1, libArr.length + 1, GC.Spread.Sheets.SheetArea.viewport).locked(false);

        // 列名称
        for (let c = 0; c <= libArr.length - 1; c++) {
            me.sheet.setText(0, c + 1, libArr[c].name, GC.Spread.Sheets.SheetArea.colHeader);
            me.sheet.setColumnWidth(c + 1, 100, GC.Spread.Sheets.SheetArea.colHeader);
            // 值明细
            let libID = libArr[c].ID;
            for (let r = 0; r < row; r++) {
                let rowName = me.sheet.getText(r, 0);
                for (let v of me.datas) {
                    if ((v.ParentID == libID) && (v.name == rowName)) {
                        me.sheet.setValue(r, c + 1, v.coe);
                        break;
                    };
                };
            };
        };
    },

    showData(){
        let me = this;
        let datas = projectObj.project.labourCoe.datas !== null ? projectObj.project.labourCoe.datas.coes : [];
        me.init();
        me.buildSheet();
        me.loadData(datas);
    }
};

$(document).ready(function(){
    $("#tab_poj-settings-6").on('shown.bs.tab', function (e) {
        labourCoeView.showData();
    });

    $("#std_labour_coe_files").change(function() {
        // 取标准库数据过来显示。
        let libID = $(this).val();
        if (libID == ''){
            labourCoeView.loadData([]);
            return false;
        };

        $.ajax({
            type:"POST",
            url: '/labourCoe/getStdLabourCoe',
            data: {"ID": libID},
            dataType: 'json',
            cache: false,
            timeout: 50000,
            success: function(result){
                if (result.error === 0) {
                    labourCoeView.buildSheet();
                    labourCoeView.loadData(result.data.coes);

                } else {
                    alert('error: ' + result.message);
                }
            },
            error: function(jqXHR, textStatus, errorThrown){
                alert('error ' + textStatus + " " + errorThrown);
            }
        });
    });
});