/**
 * Created by Mai on 2017/6/21.
 */

var projectObj = {
    project: null,
    mainSpread: null,
    mainController: null,
    gljSpreed:null,
    beforeMainTreeSelectedChange: function (node) {
        /*if (node) {
            subViewObj.saveComments(node);
        }*/
    },
    treeSelectedChanged: function (node) {
        let project = projectObj.project;
        subViewObj.loadComments(node);
        gljOprObj.showDataIfRationSelect(node);

        // CSL.2017.07.25
        if (SubActiveSheetNameIs('JSCX')) {
            if (node.sourceType === project.Bills.getSourceType() || node.sourceType === project.Ration.getSourceType()) {
                calcProgramObj.showData(node);
            } else {
                calcProgramObj.clearData();
            };
        };
        //zhong 2017-9-1 特征及内容
        if(pageCCOprObj.active){
            pageCCOprObj.mainActiveCell = projectObj.mainSpread.getActiveSheet().getSelections()[0];//mainSpread焦点单元格
            if(node.sourceType === project.Bills.getSourceType()){
                pageCCOprObj.setCacheAndShow(node);
            }
            else{
                pageCCOprObj.clearData();
            }
        }
    },
    refreshBaseActn: function (tree) {
        let setButtonValid = function (valid, btn) {
            if (valid) {
                btn.removeClass('disabled');
            } else {
                btn.addClass('disabled');
            }
        };
        let selected = tree.selected, that = projectObj;
        let canUpLevel = function (node) {
            if (selected && selected.depth() > 0 && selected.canUpLevel()) {
                if (selected.sourceType === that.project.Bills.getSourceType()) {
                    return (!selected.nextSibling) || (selected.children.length === 0) || (selected.source.children.length > 0);
                } else {
                    return false;
                }
            } else {
                return false;
            }
        };
        let canDownLevel = function (node) {
            if (selected && selected.depth() > 0 && selected.canDownLevel()) {
                if (selected.sourceType === that.project.Bills.getSourceType()) {
                    return (selected.preSibling.children.length === 0) || (selected.preSibling.source.children.length > 0);
                } else {
                    return false;
                }
            } else {
                return false;
            }
        };
        let canDelete = function (node) {
            if (selected) {
                if (selected.sourceType === that.project.Bills.getSourceType()) {
                    return !(selected.data.flagsIndex && selected.data.flagsIndex.fixed && selected.data.flagsIndex.fixed.flag > 0);
                } else {
                    return true;
                }
            } else {
                return false;
            }
        };
        setButtonValid(canUpLevel(selected), $('#upLevel'));
        setButtonValid(canDownLevel(selected), $('#downLevel'));
        setButtonValid(selected && (selected.depth() > 0) && selected.canUpMove(), $('#upMove'));
        setButtonValid(selected && (selected.depth() > 0) && selected.canDownMove(), $('#downMove'));
        setButtonValid(canDelete(selected), $('#delete'));
    },
    checkCommonField: function (editingText, colSetting) {
        let value;
        if (colSetting.data.decimal) {
            value = Number(editingText);
            if (number_util.isNumber(value)) {
                value = value.toDecimal(colSetting.data.decimal);
            } else {
                value = null;
                alert('当前输入的数据类型不正确，请重新输入。');
            }
        } else {
            value = editingText;
        }
        return value;
    },
    checkFormulaValidField: function (editingText, colSetting) {
        let value = Number(editingText);
        if (!value) {
            try {
                let exp = new Expression('');
                exp.Expression(editingText);
                value = Number(exp.Evaluate());
            } catch (error) {
                value = null;
            }
        }
        if (value) {
            value = value.toDecimal(colSetting.data.decimal);
        } else if (editingText && editingText !== '') {
            value = null;
            alert('当前输入的数据类型不正确，请重新输入。');
        }
        return value;
    },
    checkSpreadEditingText: function (editingText, colSetting) {
        if (colSetting.data.field === 'quantity' || colSetting.data.field === 'feesIndex.common.unitFee') {
            return this.checkFormulaValidField(editingText, colSetting);
        } else {
            return this.checkCommonField(editingText, colSetting);
        }
    },
    updateAndReCalculate: function (node, fieldName, value) {
        let project = projectObj.project, calc = new BillsCalcHelper(project), nodes = [];
        let getNodes = function (node) {
            let cur = node, nodes = [];
            while (cur) {
                nodes.push(cur);
                cur = cur.parent;
            }
            return nodes;
        }
        if (node.sourceType === projectObj.project.Bills.getSourceType()) {
            calcFees.setFee(node.data, fieldName, value);
            calc.calcNode(node, true);
            nodes = getNodes(node);
            project.Bills.updateNodes(nodes, true);
        } else if (node.sourceType === projectObj.project.VolumePrice.getSourceType()) {
            project.beginUpdate('VolumePrice_QuantityChange');
            project.VolumePrice.updateField(node.source, fieldName, value, false);
            calc.calcNode(node.parent, true);
            nodes = getNodes(node.parent);
            project.Bills.updateNodes(nodes, false);
            project.endUpdate();
            nodes.push(node);
        } else if (node.sourceType === projectObj.project.Ration.getSourceType()) {
            project.beginUpdate('Ration_QuantityChange');
            calcFees.setFee(node.data, fieldName, value);
            node.data.gljList = project.ration_glj.getGljArrByRation(node.data.ID);
            // calcProgram.calculate的传参必须是cacheNode类型，故无法将计算放在Ration模块中。
            project.calcProgram.calculate(node);
            project.Ration.updateRation(node.source, false);
            calc.calcNode(node.parent, true);
            nodes = getNodes(node.parent);
            project.Bills.updateNodes(nodes, false);
            project.endUpdate();
            nodes.push(node);
        }
        this.mainController.refreshTreeNode(nodes, false);
        calc = null;
    },
    updateBillsCode: function (node, value) {
        let project = projectObj.project;
        let stdMatchCode, formatCode, matchs;
        let searchStdBillsAndUpdate = function (stdCode, formatCode) {
            let orgCode = node.data.code.substr(0, 9);
            if (stdCode === orgCode || projectInfoObj.projectInfo.engineeringInfo.bill_lib.length === 0) {
                project.Bills.updateField(node.source, 'code', formatCode, true);
                projectObj.mainController.refreshTreeNode([node], false);
            } else if (projectInfoObj.projectInfo.engineeringInfo.bill_lib.length > 0) {
                let libId = projectInfoObj.projectInfo.engineeringInfo.bill_lib[0].id;
                CommonAjax.post('/stdBillsEditor/getStdBillsByCode', {userId: userID, billsLibId: libId, code: stdCode}, function (data) {
                    if (data) {
                        data.itemCharacter = pageCCOprObj.safeItemCharater(data.itemCharacter);
                        if (/\//.test(data.unit)) {
                            ConfirmModal.stdBillsUnit.check(data, function (std) {
                                project.Bills.replaceBills(node.source, std, formatCode);
                                projectObj.mainController.refreshTreeNode([node], false);
                            }, function () {
                                projectObj.mainController.refreshTreeNode([node], false);
                            });
                        } else {
                            project.Bills.replaceBills(node.source, data, formatCode);
                            projectObj.mainController.refreshTreeNode([node], false);
                        }
                    } else {
                        project.Bills.updateField(node.source, 'code', formatCode, true);
                        projectObj.mainController.refreshTreeNode([node], false);
                    }
                });
            }
        }
        if (value.length === 9 && /^[\d]+$/.test(value)) {
            stdMatchCode = value;
            formatCode = project.Bills.newFormatCode(stdMatchCode);
            searchStdBillsAndUpdate(stdMatchCode, formatCode);
        } else if (value.length === 12 && /^[\d]+$/.test(value)) {
            stdMatchCode = value.substr(0, 9);
            matchs = project.Bills.sameStdCode(stdMatchCode, node.data.code);
            if (matchs.indexOf(value) === -1) {
                searchStdBillsAndUpdate(stdMatchCode, value);
            } else if (confirm('已存在该编码的清单，是否继续？')) {
                formatCode = project.Bills.newFormatCode(stdMatchCode, node.data.code);
                searchStdBillsAndUpdate(stdMatchCode, formatCode);
            }
        } else {
            project.Bills.updateField(node.source, 'code', value, true);
            this.mainController.refreshTreeNode([node], false);
        } 
    },
    updateRationCode: function (node, value) {
        if (/[\w]{2}[\d]{4}/.test(value)) {
            if (projectInfoObj.projectInfo.engineeringInfo.ration_lib.length === 0) {
                alert('当前项目无定额库，请添加定额库。');
                this.mainController.refreshTreeNode([node], false);
            } else {
                let libId = projectInfoObj.projectInfo.engineeringInfo.ration_lib[0].id;
                CommonAjax.postRationLib('/rationRepository/api/matchRation', {user_id: userID, rationLibId: libId, code: value}, function (data) {
                    if (data) {
                        projectObj.project.Ration.replaceRation(node.source, data);
                        projectObj.project.ration_glj.addRationGLJ(node.source, data);
                    } else {
                        alert('当前库中找不到定额"' + value + '"');
                    }
                    projectObj.mainController.refreshTreeNode([node], false);
                });
            }
        } else {
            alert('输入的定额编码有误，请检查。');
            this.mainController.refreshTreeNode([node], false);
        }
    },
    updateCode: function (node, value) {
        let project = projectObj.project;
        if (node.sourceType === project.Bills.getSourceType()) {
            this.updateBillsCode(node, value);
        } else if (node.sourceType === project.Ration.getSourceType()) {
            this.updateRationCode(node, value);
        }
    },
    mainSpreadEditEnded: function (sender, info) {
        let project = projectObj.project;
        let node = project.mainTree.items[info.row];
        let colSetting = projectObj.mainController.setting.cols[info.col];
        let fieldName = projectObj.mainController.setting.cols[info.col].data.field;
        // 检查输入类型等
        let value = projectObj.checkSpreadEditingText(info.editingText, colSetting);

        if (value && value !== calcFees.getFee(node.data, fieldName)) {
            if (fieldName === 'code') {
                projectObj.updateCode(node, value);
            } else if (fieldName === 'quantity' && project.quantity_detail.quantityEditChecking(value,node,fieldName)) {
                projectObj.updateAndReCalculate(node, fieldName, value);
            } else if (fieldName === 'feesIndex.common.unitFee') {
                projectObj.updateAndReCalculate(node, fieldName, value);
            } else {
                if (node.sourceType === project.Bills.getSourceType()) {
                    project.Bills.updateField(node.source, fieldName, value, true);
                } else if (node.sourceType === project.Ration.getSourceType()) {
                    project.Ration.updateField(node.source, fieldName, value, true);
                } else if (node.sourceType === project.VolumePrice.getSourceType()) {
                    project.VolumePrice.updateField(node.source, fieldName, value, true);
                }
                if (colSetting.data.wordWrap) {
                    info.sheet.autoFitRow(info.row);
                }
                projectObj.mainController.refreshTreeNode([node]);
            }
        }
    },
    checkMainSpread: function () {
        if (!this.mainSpread) {
            this.mainSpread = SheetDataHelper.createNewSpread($('#billsSpread')[0]);
            this.mainSpread.getActiveSheet().selectionPolicy(GC.Spread.Sheets.SelectionPolicy.single);
        }
    },
    refreshMainSpread: function () {
        if (this.mainSpread) {
            this.mainSpread.refresh();
        }
    },
    loadProjectData: function () {
        var that = this;
        this.project = PROJECT.createNew(scUrlUtil.GetQueryString('project'), userID);
        this.project.loadDatas(function (err) {
            if (!err) {
                that.project.calcFields = JSON.parse(JSON.stringify(feeType));
                that.project.initCalcFields();
                let str = JSON.stringify(that.project.projSetting.main_tree_col);
                that.project.projSetting.mainGridSetting = JSON.parse(str);
                that.project.projSetting.mainGridSetting.frozenCols = 4;
                TREE_SHEET_HELPER.initSetting($('#billsSpread')[0], that.project.projSetting.mainGridSetting);
                that.project.projSetting.mainGridSetting.cols.forEach(function (col) {
                    col.data.splitFields = col.data.field.split('.');
                    if (col.data.getText && Object.prototype.toString.apply(col.data.getText) === "[object String]") {
                        col.data.getText = MainTreeCol.getEvent(col.data.getText);
                    }
                    if (col.readOnly && Object.prototype.toString.apply(col.readOnly) === "[object String]") {
                        col.readOnly = MainTreeCol.getEvent(col.readOnly);
                    }
                    if (col.data.cellType && Object.prototype.toString.apply(col.data.cellType) === "[object String]") {
                        let getCellType = MainTreeCol.getEvent(col.data.cellType);
                        col.data.cellType = getCellType();
                    }
                    if (col.data.digit && Object.prototype.toString.apply(col.data.digit) === "[object String]") {
                        col.data.decimal = that.project.getDecimal(col.data.digit);
                        col.data.formatter = MainTreeCol.getNumberFormatter(col.data.decimal);
                    }
                    if (col.data.field === 'code') {
                        col.data.formatter = '@';
                    }
                });

                that.project.calcProgram.compileAllTemps();

                that.mainController = TREE_SHEET_CONTROLLER.createNew(that.project.mainTree, that.mainSpread.getActiveSheet(), that.project.projSetting.mainGridSetting);
                that.mainController.showTreeData();
                that.mainController.bind('refreshBaseActn', that.refreshBaseActn);
                that.mainController.bind(TREE_SHEET_CONTROLLER.eventName.beforeTreeSelectedChange, that.beforeMainTreeSelectedChange);
                that.mainController.bind(TREE_SHEET_CONTROLLER.eventName.treeSelectedChanged, that.treeSelectedChanged);

                that.mainSpread.bind(GC.Spread.Sheets.Events.EditEnded, that.mainSpreadEditEnded);
                that.loadMainSpreadContextMenu();
            }
            else {

            }
        });

    },
    loadMainSpreadContextMenu: function () {
        var project = this.project, spread = this.mainSpread, controller = this.mainController;
        $.contextMenu({
            selector: '#billsSpread',
            build: function ($trigger, e) {
                var target = SheetDataHelper.safeRightClickSelection($trigger, e, spread);
                controller.setTreeSelected(controller.tree.items[target.row]);
                return target.hitTestType === GC.Spread.Sheets.SheetArea.viewport || target.hitTestType === GC.Spread.Sheets.SheetArea.rowHeader;
            },
            items: {
                "insertBills": {
                    name: "插入清单",
                    icon: 'fa-sign-in',
                    disabled: function () {
                        return project.mainTree.selected ? project.mainTree.selected.sourceType !== project.Bills.getSourceType() : false;
                    },
                    callback: function (key, opt) {
                        ProjectController.addBills(project, controller);
                    }
                },
                "insertRation": {
                    name: "插入定额",
                    icon: 'fa-sign-in',
                    disabled: function () {
                        var selected = project.mainTree.selected;
                        if (selected) {
                            if (selected.sourceType === project.Ration.getSourceType()) {
                                return false;
                            } else if (selected.sourceType === project.Bills.getSourceType()) {
                                if (selected.source.children.length === 0) {
                                    return selected.children.length !== 0 ? selected.firstChild().sourceType !== project.Ration.getSourceType() : false;
                                } else {
                                    return true;
                                }
                            } else if (selected.sourceType === project.VolumePrice.getSourceType()) {
                                return true;
                            };
                        } else {
                            return true;
                        }
                    },
                    callback: function (key, opt) {
                        ProjectController.addRation(project, controller);
                    }
                },
                "insertLJ": {
                    name: "插入量价",
                    icon: 'fa-sign-in',
                    disabled: function () {
                        var selected = project.mainTree.selected;
                        if (selected) {
                            if (selected.sourceType === project.Ration.getSourceType()) {
                                return true;
                            } else if (selected.sourceType === project.Bills.getSourceType()) {
                                if (selected.source.children.length === 0) {
                                    return selected.children.length !== 0 ? selected.firstChild().sourceType !== project.VolumePrice.getSourceType() : false;
                                } else {
                                    return true;
                                }
                            } else if (selected.sourceType === project.VolumePrice.getSourceType()) {
                                return false;
                            };
                        } else {
                            return true;
                        }
                    },
                    callback: function (key, opt) {
                        ProjectController.addVolumePrice(project, controller);
                    }
                },
                "spr1": '--------',
                "delete": {
                    name: '删除',
                    icon: 'fa-remove',
                    disabled: function () {
                        var selected = project.mainTree.selected;
                        return !selected;
                    },
                    callback: function () {
                        var selected = controller.tree.selected;
                        if (selected) {
                            if (selected.sourceType === project.Bills.getSourceType()) {
                                project.Bills.deleteBills(selected.source);
                                controller.delete();
                            } else if (selected.sourceType === project.Ration.getSourceType()) {
                                project.Ration.delete(selected.source);
                                controller.delete();
                            } else if (selected.sourceType === project.VolumePrice.getSourceType()) {
                                project.VolumePrice.delete(selected.source);
                                controller.delete();
                            };
                        }
                    }
                },
                "spr2":'--------',
                "calculateAll_RationContent": {
                    name: '造价计算',
                    callback: function () {
                        projectObj.calculateAll();
                    }
                }
            }
        });
    },
    // 计算node及node的所有父项
    converseCalculateBills: function (node) {
        let calc = new BillsCalcHelper(this.project);
        calc.calcNode(node, true);
        let cur = node, nodes = [];
        while (cur) {
            nodes.push(cur);
            cur = cur.parent;
        }
        this.mainController.refreshTreeNode(nodes, false);
        this.project.Bills.updateNodes(nodes, true);
        calc = null;
    },
    // 计算全部清单
    calculateAll: function () {
        let calc = new BillsCalcHelper(this.project);
        calc.calcAll();
        this.mainController.showTreeData();
        this.project.Bills.updateAll();
        calc = null;
    }
};

$('#insert').click(function () {
    var controller = projectObj.mainController, project = projectObj.project;
    var selected = controller.tree.selected;

    if (!selected || selected.sourceType === project.Bills.getSourceType()) {
        ProjectController.addBills(project, controller);
    } else if (selected.sourceType === project.Ration.getSourceType()) {
        ProjectController.addRation(project, controller);
    } else if (selected.sourceType === project.VolumePrice.getSourceType()) {
        ProjectController.addVolumePrice(project, controller);
    }
});
$('#delete').click(function () {
    var controller = projectObj.mainController, project = projectObj.project;
    var selected = controller.tree.selected;

    if (selected) {
        if (selected.sourceType === project.Bills.getSourceType()) {
            project.Bills.deleteBills(selected.source);
            controller.delete();
        } else if (selected.sourceType === project.Ration.getSourceType()) {
            project.Ration.delete(selected.source);
            controller.delete();
        } else if (selected.sourceType === project.VolumePrice.getSourceType()) {
            project.VolumePrice.delete(selected.source);
            controller.delete();
        };
    }
});
$('#upLevel').click(function () {
    var controller = projectObj.mainController, project = projectObj.project;
    var selected = controller.tree.selected;

    if (selected && selected.sourceType === project.Bills.getSourceType()) {
        project.Bills.upLevelBills(selected.source);
        controller.upLevel();
    }
});
$('#downLevel').click(function () {
    var controller = projectObj.mainController, project = projectObj.project;
    var selected = controller.tree.selected;
    if (selected && selected.sourceType === project.Bills.getSourceType()) {
        project.Bills.downLevelBills(selected.source);
        controller.downLevel();
    }
});
$('#upMove').click(function () {
    var controller = projectObj.mainController, project = projectObj.project;
    var selected = controller.tree.selected, pre, preSerialNo;

    if (selected.sourceType === project.Bills.getSourceType()) {
        project.Bills.upMoveBills(selected.source);
        controller.upMove();
    } else if (selected.sourceType === project.Ration.getSourceType()) {
        project.Ration.changePos(selected.source, selected.preSibling.source);
        controller.upMove();
    } else if (selected.sourceType === project.VolumePrice.getSourceType()) {
        project.VolumePrice.changePos(selected.source, selected.preSibling.source);
        controller.upMove();
    }
});
$('#downMove').click(function () {
    var controller = projectObj.mainController, project = projectObj.project;
    var selected = controller.tree.selected, next, nextSerialNo;

    if (selected.sourceType === project.Bills.getSourceType()) {
        project.Bills.downMoveBills(selected.source);
        controller.downMove();
    } else if (selected.sourceType === project.Ration.getSourceType()) {
        project.Ration.changePos(selected.source, selected.nextSibling.source);
        controller.downMove();
    } else if (selected.sourceType === project.VolumePrice.getSourceType()) {
        project.VolumePrice.changePos(selected.source, selected.nextSibling.source);
        controller.downMove();
    }
});

$('#poj-set').on('show.bs.modal', function () {
    let setCalcFlag = function (obj, val, curFlag) {
        obj.val(val);
        if (val === curFlag) {
            obj.attr('checked', true);
        } else {
            obj.removeAttr('checked');
        }
    }
    if (projectObj.project) {
        let mode = projectObj.project.projSetting.billsCalcMode;
        setCalcFlag($('#rationContent'), projectObj.project.projSetting.billsCalcModeConst.rationContent, mode);
        setCalcFlag($('#rationPrice'), projectObj.project.projSetting.billsCalcModeConst.rationPrice, mode);
        setCalcFlag($('#rationPriceConverse'), projectObj.project.projSetting.billsCalcModeConst.rationPriceConverse, mode);
        setCalcFlag($('#billsPrice'), projectObj.project.projSetting.billsCalcModeConst.billsPrice, mode);
    }
});
$('#property_ok').click(function () {
    let project = projectObj.project, mode = parseInt($("input[name='calcFlag']:checked").val());
    if (mode !== project.projSetting.billsCalcMode) {
        project.setBillsCalcMode(mode);
        projectObj.calculateAll();
        project.pushNow('editBillsCalcMode',
            [project.projSetting.moduleName, project.Bills.getSourceType()],
            [{projectID: project.ID(), billsCalcMode: project.projSetting.billsCalcMode}, project.Bills.getUpdateAllData()]
        );
    }
});
